> For the complete documentation index, see [llms.txt](https://docs.arweavekit.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.arweavekit.com/graphql/graphql-plugins.md).

# GraphQL Plugins

Plug in a external package to arweavekit/graphql

The `use` function exposed via the ArweaveKit object from `arweavekit/graphql` package allows you to plugin external packages into arweave kit package.

### Basic Syntax

The function is called as follows:

{% code title="usage.js" %}

```javascript
import * as externalPackage from 'externalPackage';
import { ArweaveKit } from 'arweavekit/graphql';

const arweaveKit = ArweaveKit.use({ name: 'MyPlugIn', plugin: externalPackage });

console.log(arweavekit.functionFromExternalPackage())
```

{% endcode %}

{% hint style="info" %}
The ArweaveKit object imported also contains all functions from the ArweaveKit package for ease of use.
{% endhint %}

### Create a Plugin

Most existing packages in Arweave will already be supported without any additional work, the functions just need to be defined and exported in the external package:

{% code title="externalPackage.js" %}

```javascript
import * as ExternalPackage from 'package'
export function PackagePlugIn() {
    return ExternalPackage
}
```

{% endcode %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.arweavekit.com/graphql/graphql-plugins.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
